from rest_framework import serializers

from backoffice.models import Reference, Authority, ReferenceType

class ReferenceSerializer(serializers.ModelSerializer):

    admin_link = serializers.SerializerMethodField()

    def get_admin_link(self, reference):
        return reference.get_admin_url()

    class Meta:
        model = Reference
        exclude = ('disabled',)
        depth = 1

class LightReferenceSerializer(serializers.ModelSerializer):

    class Meta:
        model = Reference
        fields = ('id', 'identifier', 'number', 'authority', 'reference_type',
                  'title', 'title_short', 'ecli', 'section', 'issued_date')
        depth = 1


class AuthoritySerializer(serializers.ModelSerializer):

    class Meta:
        model = Authority
        fields = '__all__'

class ReferenceTypeSerializer(serializers.ModelSerializer):

    class Meta:
        model = ReferenceType
        fields = '__all__'